//
//  BGBlurEffect.h
//  Epics
//
//  Created by Dominic Rodemer on 16.12.13.
//  Copyright (c) 2013 brandagram GmbH. All rights reserved.
//

#import <Foundation/Foundation.h>

#if (TARGET_OS_EMBEDDED || TARGET_OS_IPHONE)
#import <UIKit/UIKit.h>
#else
#import <Cocoa/Cocoa.h>
#endif

@interface BGBlurEffect : NSObject

@property (nonatomic, assign) CGRect cropRect;
@property (nonatomic, assign) CGSize resize;
@property (nonatomic, assign) CGFloat radius;

#if (TARGET_OS_EMBEDDED || TARGET_OS_IPHONE)
@property (nonatomic, strong) UIColor *tintColor;
#else
@property (nonatomic, strong) NSColor *tintColor;
#endif

@property (nonatomic, assign) CGFloat saturationDeltaFactor;

#if (TARGET_OS_EMBEDDED || TARGET_OS_IPHONE)
@property (nonatomic, strong) UIImage *maskImage;
#else
@property (nonatomic, strong) NSImage *maskImage;
#endif

+ (instancetype)blurEffect;
+ (instancetype)lightBlurEffect;
+ (instancetype)darkBlurEffect;

#if (TARGET_OS_EMBEDDED || TARGET_OS_IPHONE)
- (UIImage *)blurImage:(UIImage *)image;
#else
- (NSImage *)blurImage:(NSImage *)image;
#endif

@end
