//
//  BGFoundation.h
//  BGFoundation
//
//  Created by Dominic Rodemer on 05/01/16.
//  Copyright © 2016 brandgram GmbH. All rights reserved.
//

#import <Foundation/Foundation.h>

//! Project version number for BGFoundation.
FOUNDATION_EXPORT double BGFoundationVersionNumber;

//! Project version string for BGFoundation.
FOUNDATION_EXPORT const unsigned char BGFoundationVersionString[];

#import <BGFoundation/BGLogging.h>
#import <BGFoundation/BGDispatch.h>
#import <BGFoundation/BGMath.h>

#import <BGFoundation/BGSortedList.h>
#import <BGFoundation/BGRange.h>

#import <BGFoundation/BGInputValidator.h>
#import <BGFoundation/BGEqualInputValidator.h>
#import <BGFoundation/BGLengthInputValidator.h>
#import <BGFoundation/BGMailInputValidator.h>
#import <BGFoundation/BGNotEmptyInputValidator.h>
#import <BGFoundation/BGRegExInputValidator.h>

#import <BGFoundation/BGImageCache.h>

#import <BGFoundation/BGNetworkReachability.h>

#import <BGFoundation/BGBlurEffect.h>

#if (TARGET_OS_EMBEDDED || TARGET_OS_IPHONE)

#else
#import <BGFoundation/BGScalableImage.h>
#endif

#import <BGFoundation/BGRate.h>
#import <BGFoundation/BGTimeIntervalFormatter.h>
#import <BGFoundation/BGKeychain.h>
#import <BGFoundation/BGFileMonitor.h>
#import <BGFoundation/BGRetriggerableTimer.h>
#import <BGFoundation/BGAction.h>
#import <BGFoundation/BGApplicationInformation.h>
#import <BGFoundation/BGiTunesAffiliateManager.h>

#if (TARGET_OS_EMBEDDED || TARGET_OS_IPHONE)
#import <BGFoundation/BGDeviceOrientationManager.h>
#ifdef BG_LOCATION_SERVICES
#import <BGFoundation/BGLocationManager.h>
#endif
#else

#endif

#import <BGFoundation/BGObjectSerialization.h>

#import <BGFoundation/NSData+BGFoundation.h>
#import <BGFoundation/NSDateFormatter+BGFoundation.h>
#import <BGFoundation/NSNumberFormatter+BGFoundation.h>
#import <BGFoundation/NSDictionary+BGFoundation.h>
#import <BGFoundation/NSMutableDictionary+BGFoundation.h>
#import <BGFoundation/NSFileManager+BGFoundation.h>
#import <BGFoundation/NSJSONSerialization+BGFoundation.h>
#import <BGFoundation/NSArray+BGFoundation.h>
#import <BGFoundation/NSMutableArray+BGFoundation.h>
#import <BGFoundation/NSObject+BGFoundation.h>
#import <BGFoundation/NSString+BGFoundation.h>
#import <BGFoundation/NSInvocation+BGFoundation.h>
#import <BGFoundation/NSIndexPath+BGFoundation.h>

#if (TARGET_OS_EMBEDDED || TARGET_OS_IPHONE)
#import <BGFoundation/UIColor+BGFoundation.h>
#import <BGFoundation/UIDevice+BGFoundation.h>
#import <BGFoundation/UIFont+BGFoundation.h>
#import <BGFoundation/UIImage+BGFoundation.h>
#import <BGFoundation/UITraitCollection+BGFoundation.h>
#else
#import <BGFoundation/NSColor+BGFoundation.h>
#import <BGFoundation/NSBezierPath+BGFoundation.h>
#import <BGFoundation/NSImage+BGFoundation.h>
#import <BGFoundation/NSDocument+BGFoundation.h>
#endif
