//
//  BGKeychain.h
//  BGFoundation
//
//  Created by Dominic Rodemer on 13.03.14.
//  Copyright (c) 2014 brandagram GmbH. All rights reserved.
//

#import <Foundation/Foundation.h>

#import <Security/Security.h>


#ifndef BG_KEYCHAIN_USE_NSCODING
    #if (TARGET_OS_EMBEDDED || TARGET_OS_IPHONE)
        #define BG_KEYCHAIN_USE_NSCODING 1
    #else
        #define BG_KEYCHAIN_USE_NSCODING 0
    #endif
#endif


typedef NS_ENUM(NSInteger, BGKeychainAccess)
{
    BGKeychainAccessibleWhenUnlocked = 0,
    BGKeychainAccessibleAfterFirstUnlock,
    BGKeychainAccessibleAlways,
    BGKeychainAccessibleWhenUnlockedThisDeviceOnly,
    BGKeychainAccessibleAfterFirstUnlockThisDeviceOnly,
    BGKeychainAccessibleAlwaysThisDeviceOnly
};


@interface BGKeychain : NSObject
{
    
}

@property (nonatomic, strong, readonly) NSString *service;
@property (nonatomic, strong, readonly) NSString *accessGroup;
@property (nonatomic, assign) BGKeychainAccess accessibility;

+ (void)setDefaultKeychainAccessGroup:(NSString *)accessGroup;
+ (instancetype)defaultKeychain;

- (id)initWithService:(NSString *)service accessGroup:(NSString *)accessGroup accessibility:(BGKeychainAccess)accessibility;
- (id)initWithService:(NSString *)service accessGroup:(NSString *)accessGroup;

- (BOOL)setObject:(id)object forKey:(id)key;
- (BOOL)setObject:(id)object forKeyedSubscript:(id)key;
- (BOOL)removeObjectForKey:(id)key;
- (id)objectForKey:(id)key;
- (id)objectForKeyedSubscript:(id)key;

@end