//
//  BGMath.h
//  BGFoundation
//
//  Created by Dominic Rodemer on 07/01/16.
//  Copyright © 2016 brandgram GmbH. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <CoreGraphics/CoreGraphics.h>

//Constants
extern CGFloat const kBGEllipseFactor;
extern CGFloat const kBGPiBy180;
extern CGFloat const kBG180ByPi;


//Geometry
CGSize BGSwapWidthAndHeight(CGSize size);
CGFloat BGDegreesToRadians(CGFloat degrees);
CGFloat BGRadiansToDegrees(CGFloat radians);
CGFloat BGDistanceBetweenPoints(CGPoint a, CGPoint b);

//Bezier Paths
void BGSubdivideBezierPath(const CGPoint bez[4], CGPoint bez1[4], CGPoint bez2[4]);
void BGSubdivideBezierPathAtT(const CGPoint bez[4], CGPoint bez1[4], CGPoint bez2[4], CGFloat t);
CGFloat BGLengthOfBezierPath(const  CGPoint bez[4], CGFloat acceptableError);
double BGSubdivideBezierPathAtLength(const CGPoint bez[4], CGPoint bez1[4], CGPoint bez2[4], CGFloat length, CGFloat acceptableError);