//
//  BGNetworkReachability.h
//  BGFoundation
//
//  Created by Dominic Rodemer on 26/04/15.
//  Copyright (c) 2015 brandagram GmbH. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <SystemConfiguration/SystemConfiguration.h>

extern NSString *const BGNetworkReachabilityStatusDidChangeNotification;

extern NSString *const BGNetworkReachabilityNotificationStatusKey;
extern NSString *const BGNetworkReachabilityNotificationPreviousStatusKey;
extern NSString *const BGNetworkReachabilityNotificationHostKey;


typedef NS_ENUM(NSInteger, BGNetworkReachabilityStatus) {
    BGNetworkReachabilityStatusUnknown  = -1,
    BGNetworkReachabilityStatusNotReachable = 0,
#if (TARGET_OS_EMBEDDED || TARGET_OS_IPHONE)
    BGNetworkReachabilityStatusReachableViaCellular = 1,
    BGNetworkReachabilityStatusReachableViaWiFi = 2
#else
    BGNetworkReachabilityStatusReachable = 1
#endif
};


@interface BGNetworkReachability : NSObject
{
    SCNetworkReachabilityRef reachability;
    BGNetworkReachabilityStatus status;
    NSString *host;
}

@property (nonatomic, readonly) BGNetworkReachabilityStatus status;
@property (nonatomic, copy) NSString *host;

+ (BGNetworkReachability *)sharedReachability;
+ (BOOL)isReachable;

- (id)initWithHost:(NSString *)hostDomain;
- (BOOL)isReachable;

@end
