//
//  BGScalableImage.h
//  BGFoundation
//
//  Created by Dominic Rodemer on 20/01/16.
//  Copyright © 2016 brandgram GmbH. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@interface BGScalableImage : NSObject
{
    
}

+ (instancetype)scaleableImageWithImage:(NSImage *)image;
+ (instancetype)scaleableImageWithLeftImageNamed:(NSString *)leftName centerImageNamed:(NSString *)centerName rightImageNamed:(NSString *)rightName;
+ (instancetype)scaleableImageWithImage:(NSImage *)image leftCapWidth:(CGFloat)leftWidth rightCapWidth:(CGFloat)rightWidth;
+ (instancetype)scaleableImageWithLeftImage:(NSImage *)leftImage centerImage:(NSImage *)centerImage rightImage:(NSImage *)rightImage;

- (void)drawInRect:(NSRect)rect;
- (void)drawInRect:(NSRect)rect operation:(NSCompositingOperation)operation fraction:(CGFloat)fraction flipped:(BOOL)flipped;

- (NSImage *)scaledImageWithSize:(NSSize)size;

@end
