//
//  BGSortedList.h
//  BGFoundation
//
//  Created by Dominic Rodemer on 26/04/15.
//  Copyright (c) 2015 brandagram GmbH. All rights reserved.
//

#import <Foundation/Foundation.h>

@interface BGSortedList : NSObject <NSFastEnumeration>
{
    NSSortDescriptor *sortDescriptor;
    NSMutableArray *backingArray;
}

@property (nonatomic, strong, readonly) NSSortDescriptor *sortDescriptor;

@property (readonly) NSUInteger count;
@property (nonatomic, readonly) id firstObject;
@property (nonatomic, readonly) id lastObject;

- (id)initWithSortDescriptor:(NSSortDescriptor *)aSortDescriptor;

- (id)objectAtIndex:(NSUInteger)index;
- (NSArray *)allObjects;

- (NSUInteger)indexForInsertingObject:(id)anObject;
- (NSUInteger)indexOfObject:(id)anObject;

- (void)insertObject:(id)anObject;

- (void)removeObject:(id)anObject;
- (void)removeObjectAtIndex:(NSUInteger)index;
- (void)removeAllObjects;

- (NSEnumerator *)objectEnumerator;
- (NSEnumerator *)reverseObjectEnumerator;

@end
