//
//  BGTimeIntervalFormatter.h
//  BGFoundation
//
//  Created by Dominic Rodemer on 14/10/14.
//  Copyright (c) 2014 brandagram GmbH. All rights reserved.
//

#import <Foundation/Foundation.h>

@interface BGTimeIntervalFormatter : NSFormatter
{
    NSLocale *locale;
    NSCalendar *calendar;
    
    NSString *pastDeicticExpression;
    NSString *presentDeicticExpression;
    NSString *futureDeicticExpression;
    NSString *deicticExpressionFormat;
    NSString *suffixExpressionFormat;
    NSTimeInterval presentTimeIntervalMargin;
    BOOL usesIdiomaticDeicticExpressions;
    
    NSString *approximateQualifierFormat;
    BOOL usesApproximateQualifier;
    NSUInteger significantUnits;
    NSUInteger numberOfSignificantUnits;
    
    NSCalendarUnit leastSignificantUnit;
    
    BOOL usesAbbreviatedCalendarUnits;
}

@property (nonatomic, strong) NSLocale *locale;
@property (nonatomic, strong) NSCalendar *calendar;

@property (nonatomic, copy) NSString *pastDeicticExpression;
@property (nonatomic, copy) NSString *presentDeicticExpression;
@property (nonatomic, copy) NSString *futureDeicticExpression;
@property (nonatomic, copy) NSString *deicticExpressionFormat;
@property (nonatomic, strong) NSString *suffixExpressionFormat;
@property (nonatomic, assign) NSTimeInterval presentTimeIntervalMargin;
@property (nonatomic, assign) BOOL usesIdiomaticDeicticExpressions;

@property (nonatomic, copy) NSString *approximateQualifierFormat;
@property (nonatomic, assign) BOOL usesApproximateQualifier;
@property (nonatomic, assign) NSUInteger significantUnits;
@property (nonatomic, assign) NSUInteger numberOfSignificantUnits;

@property (nonatomic, assign) NSCalendarUnit leastSignificantUnit;

@property (nonatomic, assign) BOOL usesAbbreviatedCalendarUnits;

- (NSString *)stringForTimeInterval:(NSTimeInterval)seconds;

- (NSString *)stringForTimeIntervalFromDate:(NSDate *)startingDate
                                     toDate:(NSDate *)endingDate;

@end
