//
//  NSArray+BGFoundation.h
//  BGFoundation
//
//  Created by Dominic Rodemer on 04/08/16.
//  Copyright © 2016 brandgram GmbH. All rights reserved.
//

#import <Foundation/Foundation.h>

@interface NSArray (BGFoundation)

+ (NSArray *)bg_arrayWithContentsOfEncryptedFile:(NSString *)path withKey:(NSData *)key;

- (NSArray *)bg_uniqueMembers;
- (NSArray *)bg_unionWithArray:(NSArray *)anArray; //Vereiningung
- (NSArray *)bg_intersectionWithArray:(NSArray *)anArray; //Schnittmenge
- (NSArray *)bg_differenceWithArray:(NSArray *)anArray; //Komplement

- (NSArray *)bg_arrayByInsertingObjectsFromArray:(NSArray *)anArray atIndex:(NSUInteger)startIndex;

- (NSArray *)bg_arrayByRemovingFirstObject;
- (NSArray *)bg_arrayByRemovingLastObject;
- (NSArray *)bg_arrayByRemovingObjectAtIndex:(NSUInteger)index;
- (NSArray *)bg_arrayByRemovingObjectsInRange:(NSRange)range;
- (NSArray *)bg_arrayByRemovingObject:(id)anObject;
- (NSArray *)bg_arrayByRemovingObjectsFromArray:(NSArray *)anArray;

- (NSArray *)bg_reverseArray;

@end
