//
//  NSBezierPath+BGFoundation.h
//  BGFoundation
//
//  Created by Dominic Rodemer on 19/12/15.
//  Copyright © 2015 brandagram GmbH. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@interface NSBezierPath (BGFoundation)

+ (NSBezierPath *)bg_bezierPathWithRoundRect:(NSRect)inRect xRadius:(CGFloat)inRadiusX yRadius:(CGFloat)inRadiusY;

- (NSPoint)bg_firstPoint;
- (CGFloat)bg_length;
- (CGFloat)bg_lengthWithMaximumError:(CGFloat)maxError;

- (NSBezierPath *)bg_bezierPathByTrimmingToLength:(CGFloat)trimLength;
- (NSBezierPath *)bg_bezierPathByTrimmingToLength:(CGFloat)trimLength withMaximumError:(CGFloat)maxError;

- (NSBezierPath *)bg_bezierPathByTrimmingFromLength:(CGFloat)trimLength;
- (NSBezierPath *)bg_bezierPathByTrimmingFromLength:(CGFloat)trimLength withMaximumError:(CGFloat)maxError;

- (NSBezierPath *)bg_bezierPathWithArrowHeadForStartOfLength:(CGFloat)length angle:(CGFloat)degrees;
- (NSBezierPath *)bg_bezierPathWithArrowHeadForEndOfLength:(CGFloat)length angle:(CGFloat)degrees;

- (void)bg_appendBezierPathRemovingInitialMoveToPoint:(NSBezierPath *)path;

@end