//
//  NSColor+BGFoundation.h
//  BGFoundation
//
//  Created by Dominic Rodemer on 09/11/15.
//  Copyright © 2015 brandagram GmbH. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@interface NSColor (BGFoundation)

+ (NSColor *)bg_colorWithWhite:(CGFloat)white alpha:(CGFloat)alpha;
+ (NSColor *)bg_colorWithRed:(CGFloat)red green:(CGFloat)green blue:(CGFloat)blue alpha:(CGFloat)alpha;
+ (NSColor *)bg_contrastingColor:(NSColor *)color;

- (NSColor *)bg_colorWithRGBBlendFrom:(NSColor*)color blendingAmounts:(CGFloat[])blends;

- (CGFloat)bg_luminosity;

- (NSColor *)bg_contrastingColor;

- (NSColor *)bg_colorWithAlpha:(CGFloat)alpha;

- (NSColor *)bg_darkerColorBy:(CGFloat)darken;
- (NSColor *)bg_darkerColor;

- (NSColor *)bg_lighterColorBy:(CGFloat)lighten;
- (NSColor *)bg_lighterColor;

+ (NSColor *)bg_colorWithRGBHex:(UInt32)hex;
+ (NSColor *)bg_colorWithRGBAHex:(UInt32)hex;
+ (NSColor *)bg_colorWithHexString:(NSString *)stringToConvert;
- (NSString *)bg_hexStringFromColor;

@end
