//
//  NSFileManager+BGFoundation.h
//  BGFoundation
//
//  Created by Dominic Rodemer on 02/03/15.
//  Copyright (c) 2015 brandagram GmbH. All rights reserved.
//

#import <Foundation/Foundation.h>

@interface NSFileManager (BGFoundation)

+ (void)bg_removeItemAtURLInBackground:(NSURL *)url completionBlock:(void (^)(BOOL success, NSError *error))completion;
+ (void)bg_removeItemAtPathInBackground:(NSString *)path completionBlock:(void (^)(BOOL success, NSError *error))completion;

+ (void)bg_removeContentsOfDirectoryAtPathInBackground:(NSString *)path completionBlock:(void (^)(BOOL success, NSError *error))completion;
+ (void)bg_removeItemsAtPathsInBackground:(NSArray *)paths completionBlock:(void (^)(BOOL success, NSError *error))completion;

- (BOOL)bg_copyItemAtURL:(NSURL *)url toURL:(NSURL *)toURL overwrite:(BOOL)overwrite error:(NSError **)error;
- (BOOL)bg_copyItemAtPath:(NSString *)path toPath:(NSString *)toPath overwrite:(BOOL)overwrite error:(NSError **)error;

- (BOOL)bg_moveItemAtURL:(NSURL *)url toURL:(NSURL *)toURL overwrite:(BOOL)overwrite error:(NSError **)error;
- (BOOL)bg_moveItemAtPath:(NSString *)path toPath:(NSString *)toPath overwrite:(BOOL)overwrite error:(NSError **)error;

- (unsigned long long)bg_direcorySize:(NSString *)directoryPath;
- (unsigned long long)bg_direcorySizeAtURL:(NSURL *)directoryURL;
- (unsigned long long)bg_sizeOfFilesAtPaths:(NSArray *)files;

- (NSString *)bg_formatedSize:(unsigned long long)fileSize __attribute__((deprecated("Use [[NSNumberFormatter bg_fileSizeFormatter] bg_formatedFileSize:] instead")));
- (NSString *)bg_formatedSizeOfDirectory:(NSString *)directoryPath;
- (NSString *)bg_formatedSizeOfFilesAtPaths:(NSArray *)files;

- (NSString *)bg_uniquePathForFile:(NSString *)file inPath:(NSString *)path;
- (NSString *)bg_uniqueRandomPathForFileWithExtension:(NSString *)extension inPath:(NSString *)path;
- (NSString *)bg_uniqueRandomDirectoryPathInPath:(NSString *)path;

@end
