//
//  NSImage+BGFoundation.h
//  BGFoundation
//
//  Created by Dominic Rodemer on 02/09/16.
//  Copyright © 2016 brandgram GmbH. All rights reserved.
//

#import <Cocoa/Cocoa.h>

typedef NS_ENUM(NSInteger, BGNSImageResizingMode) {
    BGNSImageResizingModeScaleToFill = 0,
    BGNSImageResizingModeAspectFit,
    BGNSImageResizingModeAspectFill
};


@interface NSImage (BGFoundation)

+ (NSImage *)bg_imageWithCGImage:(CGImageRef)cgImage;

- (NSImage *)bg_imageByScalingToSize:(CGSize)newSize usingMode:(BGNSImageResizingMode)resizeMode;
- (NSImage *)bg_imageByScalingToFillSize:(CGSize)newSize;
- (NSImage *)bg_imageByScalingToFitSize:(CGSize)newSize;
- (NSImage *)bg_imageByScalingToAspectFillSize:(CGSize)newSize;

- (NSImage *)bg_imageByRotatingInRadians:(CGFloat)radians;
- (NSImage *)bg_imageByRotatingInDegrees:(CGFloat)degrees;

- (NSImage *)bg_imageByCroppingToRect:(CGRect)rect;

@end
