//
//  NSString+BGFoundation.h
//  BGFoundation
//
//  Created by Dominic Rodemer on 02/03/15.
//  Copyright (c) 2015 brandagram GmbH. All rights reserved.
//

#import <Foundation/Foundation.h>

@interface NSString (BGFoundation)

+ (NSString *)bg_userDirectoryPathForSearchPath:(NSSearchPathDirectory)searchPath;
+ (NSString *)bg_documentsDirectoryPath;
+ (NSString *)bg_cachesDirectoryPath;
+ (NSString *)bg_temporaryDirectoryPath;
+ (NSString *)bg_applicationSupportDirectoryPath;
+ (NSString *)bg_libraryDirectoryPath;

- (NSString *)bg_stringWithPathRelativeTo:(NSString*)anchorPath;
- (NSString *)bg_stringWithPathRelativeToMainBundle;

- (NSString *)bg_md5Hash;
- (NSString *)bg_sha1Hash;
- (NSString *)bg_sha256Hash;

+ (NSString *)bg_URLEncodeString:(NSString *)string;
- (NSString *)bg_URLEncodedString;
+ (NSString *)bg_URLDecodeString:(NSString *)string;
- (NSString *)bg_URLDecodedString;
- (NSString *)bg_URLStringByAppendingParameter:(NSString *)parameter withValue:(NSString *)value;

- (NSString *)bg_trimedString;
- (NSString *)bg_stringByRemovingPrefix:(NSString *)prefix;
- (NSString *)bg_stringByRemovingSuffix:(NSString *)suffix;

+ (NSString *)bg_stringWithContentsOfEncryptedFile:(NSString *)path withKey:(NSData *)key encoding:(NSStringEncoding)encoding;

@end
