//
//  MPAdjustmentSliderCell.m
//  MoviePlayer
//
//  Created by Dominic Rodemer on 27/03/2017.
//  Copyright © 2017 Dominic Rodemer. All rights reserved.
//

#import "MPAdjustmentSliderCell.h"

CGFloat const MPAdjustmentSliderKnobWidth = 3.0;
CGFloat const MPAdjustmentSliderKnobHeight = 17.0;

@implementation MPAdjustmentSliderCell

- (void)drawKnob:(NSRect)knobRect
{
    [[NSColor colorWithCalibratedRed:0.0
                               green:0.25
                                blue:0.8
                               alpha:1.0] setFill];
    NSRectFill(knobRect);
}

- (void)drawBarInside:(NSRect)cellFrame flipped:(BOOL)flipped
{
    NSRect barRect = cellFrame;
    barRect.size.height = MPAdjustmentSliderKnobHeight;
    
    NSRect fillRect = barRect;
    NSRect knobRect = [self knobRectFlipped:flipped];
    fillRect.size.width = knobRect.origin.x;
    
    NSBezierPath *barPath = [NSBezierPath bezierPathWithRect:barRect];
    [[NSColor colorWithCalibratedWhite:0.15
                                 alpha:1.0] setFill];
    [barPath fill];
    
    NSBezierPath *fillPath = [NSBezierPath bezierPathWithRect:fillRect];
    [[NSColor colorWithCalibratedWhite:0.4
                                 alpha:1.0] setFill];
    [fillPath fill];
}

- (NSRect)barRectFlipped:(BOOL)flipped
{
    return NSMakeRect(0, 0, NSWidth(self.controlView.frame), NSHeight(self.controlView.frame));
}

- (NSRect)knobRectFlipped:(BOOL)flipped
{
    
    CGFloat value = (self.doubleValue - self.minValue) / (self.maxValue - self.minValue);
    
    NSRect newRect = NSMakeRect(0, 0, 0, 0);
    newRect.size.width = MPAdjustmentSliderKnobWidth;
    newRect.size.height = MPAdjustmentSliderKnobHeight;
    newRect.origin.x = value * (NSWidth(self.controlView.frame) - MPAdjustmentSliderKnobWidth);
    
    return newRect;
}

@end
