//
//  MPPlayerControlView.h
//  MoviePlayer
//
//  Created by Dominic Rodemer on 23/03/2017.
//  Copyright © 2017 Dominic Rodemer. All rights reserved.
//

#import <Cocoa/Cocoa.h>

#import <VLCKit/VLCKit.h>

@interface MPPlayerControlView : NSVisualEffectView
{
    BOOL visible;
    
    NSButton *playButton;
    NSButton *nextButton;
    NSButton *jumpForwardButton;
    NSButton *previousButton;
    NSButton *jumpBackwardButton;
    
    NSSlider *volumeSlider;
    NSButton *volumeUpButton;
    NSButton *volumeDownButton;
    
    NSButton *equalizerButton;
    NSButton *videoAdjustmentsButton;
    NSButton *playlistButton;
    
    NSSlider *timeSlider;
    NSTextField *currentTimeLabel;
    NSTextField *timeLeftLabel;
}

@property (nonatomic, readonly, getter=isVisible) BOOL visible;

@property (nonatomic, strong) IBOutlet NSButton *playButton;
@property (nonatomic, strong) IBOutlet NSButton *nextButton;
@property (nonatomic, strong) IBOutlet NSButton *jumpForwardButton;
@property (nonatomic, strong) IBOutlet NSButton *previousButton;
@property (nonatomic, strong) IBOutlet NSButton *jumpBackwardButton;
@property (nonatomic, strong) IBOutlet NSSlider *volumeSlider;
@property (nonatomic, strong) IBOutlet NSButton *volumeUpButton;
@property (nonatomic, strong) IBOutlet NSButton *volumeDownButton;
@property (nonatomic, strong) IBOutlet NSButton *equalizerButton;
@property (nonatomic, strong) IBOutlet NSButton *videoAdjustmentsButton;
@property (nonatomic, strong) IBOutlet NSButton *playlistButton;
@property (nonatomic, strong) IBOutlet NSSlider *timeSlider;
@property (nonatomic, strong) IBOutlet NSTextField *currentTimeLabel;
@property (nonatomic, strong) IBOutlet NSTextField *timeLeftLabel;

- (void)showAnimated:(BOOL)animated;
- (void)hideAnimated:(BOOL)animated;

- (void)enableTimeSlider;
- (void)disableTimeSlider;
- (void)updateTimeSliderWithCurrentTime:(VLCTime *)currentTime remainingTime:(VLCTime *)remainingTime;

@end
