//
//  MPPlayerWindowController.h
//  MoviePlayer
//
//  Created by Dominic Rodemer on 09/03/2017.
//  Copyright © 2017 Dominic Rodemer. All rights reserved.
//

#import <Cocoa/Cocoa.h>

#import <VLCKit/VLCKit.h>

#import "MPPlaylistViewController.h"
#import "MPVideoAdjustmentsViewController.h"
#import "MPEqualizerViewController.h"

#import "MPVideoContainerView.h"
#import "MPVideoView.h"
#import "MPPlayerControlView.h"
#import "MPPlayerWindow.h"

@interface MPPlayerWindowController : NSWindowController <VLCMediaPlayerDelegate,
                                                          MPSidePanelViewControllerDelegate>
{
    VLCMediaList *mediaList;
    
    VLCMediaListPlayer *listPlayer;
    NSTimer *hideControlsTimer;

    MPPlaylistViewController *playlistViewController;
    MPVideoAdjustmentsViewController *videoAdjustmentsViewController;
    MPEqualizerViewController *equalizerViewController;
    __weak MPSidePanelViewController *visibleSidePanelViewController;
    
    MPVideoContainerView *videoContainerView;
    MPVideoView *videoView;
    MPPlayerControlView *playerControlView;
    
    CGSize nativeVideoSize;
}

@property (atomic, strong) MPPlayerWindow *window;

@property (nonatomic, strong, readonly) VLCMediaList *mediaList;

@property (nonatomic, strong) IBOutlet MPVideoContainerView *videoContainerView;
@property (nonatomic, strong) IBOutlet MPVideoView *videoView;
@property (nonatomic, strong) IBOutlet MPPlayerControlView *playerControlView;

- (id)initWithMediaItems:(NSArray <VLCMedia *>*)mediaItems;

- (void)addMediaItems:(NSArray <VLCMedia *>*)mediaItems autoplayItem:(VLCMedia *)autoplayItem;

- (void)showControlsAnimated:(BOOL)animated;
- (void)hideControlsAnimated:(BOOL)animated;

@end
