//
//  MPPlaylistViewController.h
//  MoviePlayer
//
//  Created by Dominic Rodemer on 27/03/2017.
//  Copyright © 2017 Dominic Rodemer. All rights reserved.
//

#import "MPSidePanelViewController.h"

#import <VLCKit/VLCKit.h>

@interface MPPlaylistViewController : MPSidePanelViewController <VLCMediaListDelegate,
                                                                 NSMenuDelegate,
                                                                 NSTableViewDelegate,
                                                                 NSTableViewDataSource>
{
    __weak VLCMediaList *mediaList;
    __weak VLCMediaListPlayer *listPlayer;
    
    NSScrollView *scrollView;
    NSTableView *tableView;
    NSButton *addButton;
    NSButton *removeButton;
    
    NSRange draggingRange;
    NSArray *draggedItems;
}

@property (nonatomic, weak, readonly) VLCMediaList *mediaList;
@property (nonatomic, weak, readonly) VLCMediaListPlayer *listPlayer;

@property (nonatomic, strong) IBOutlet NSScrollView *scrollView;
@property (nonatomic, strong) IBOutlet NSTableView *tableView;
@property (nonatomic, strong) IBOutlet NSButton *addButton;
@property (nonatomic, strong) IBOutlet NSButton *removeButton;

- (id)initWithMediaList:(VLCMediaList *)aMediaList andListPlyer:(VLCMediaListPlayer *)aListPlayer;

- (void)addFilesToPlaylist;

- (BOOL)hasNextItem;
- (void)playNextItem;

- (BOOL)hasPreviousItem;
- (void)playPreviousItem;

@end
