//
//  MPSidePanelViewController.h
//  MoviePlayer
//
//  Created by Dominic Rodemer on 27/03/2017.
//  Copyright © 2017 Dominic Rodemer. All rights reserved.
//

#import <Cocoa/Cocoa.h>

typedef NS_ENUM(NSUInteger, MPSidePanelViewControllerEdge) {
    MPSidePanelViewControllerEdgeRight = 0,
    MPSidePanelViewControllerEdgeLeft,
    MPSidePanelViewControllerEdgeTop,
    MPSidePanelViewControllerEdgeBottom
};

@protocol MPSidePanelViewControllerDelegate;

@protocol MPSidePanelViewControllerSubclassingHooks <NSObject>

- (void)sidePanelDidShow;

@end

@interface MPSidePanelViewController : NSViewController <MPSidePanelViewControllerSubclassingHooks>
{
    __weak id<MPSidePanelViewControllerDelegate> delegate;
    
    BOOL visible;
    
    MPSidePanelViewControllerEdge visibleFromEdge;
}

@property (nonatomic, weak) id<MPSidePanelViewControllerDelegate> delegate;

@property (nonatomic, readonly) BOOL visible;
@property (nonatomic, readonly) MPSidePanelViewControllerEdge visibleFromEdge;

- (void)showFromEdge:(MPSidePanelViewControllerEdge)edge animated:(BOOL)animated;
- (void)hideToEdge:(MPSidePanelViewControllerEdge)edge animated:(BOOL)animated;

@end


@protocol MPSidePanelViewControllerDelegate <NSObject>

@optional
- (void)sidePanelViewControllerWillShow:(MPSidePanelViewController *)controller animated:(BOOL)animated;
- (void)sidePanelViewControllerDidShow:(MPSidePanelViewController *)controller animated:(BOOL)animated;
- (void)sidePanelViewControllerWillHide:(MPSidePanelViewController *)controller animated:(BOOL)animated;

@end
