//
//  MPTrackingView.h
//  MoviePlayer
//
//  Created by Dominic Rodemer on 22/03/2017.
//  Copyright © 2017 Dominic Rodemer. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@interface MPTrackingView : NSView
{
    NSTrackingArea *trackingArea;
    
    void (^mouseEnteredHandler)(void);
    void (^mouseExitedHandler)(void);
    void (^mouseMovedHandler)(void);
    
    BOOL trackingEnabled;
}

@property (nonatomic, strong, readonly) NSTrackingArea *trackingArea;

@property (nonatomic, copy) void (^mouseEnteredHandler)(void);
@property (nonatomic, copy) void (^mouseExitedHandler)(void);
@property (nonatomic, copy) void (^mouseMovedHandler)(void);

@property (nonatomic) BOOL trackingEnabled;

@end
