//
//  MPVideoAdjustmentsViewController.m
//  MoviePlayer
//
//  Created by Dominic Rodemer on 27/03/2017.
//  Copyright © 2017 Dominic Rodemer. All rights reserved.
//

#import "MPVideoAdjustmentsViewController.h"

#import <BGDataBinding/BGDataBinding.h>

@interface MPVideoAdjustmentsViewController ()

@end

@implementation MPVideoAdjustmentsViewController

@synthesize player;

@synthesize brightnessSlider;
@synthesize contrastSlider;
@synthesize gammaSlider;
@synthesize hueSlider;
@synthesize saturationSlider;

- (id)initWithMediaPlayer:(VLCMediaPlayer *)aPlayer
{
    if (self = [super initWithNibName:@"MPVideoAdjustmentsViewController" bundle:nil])
    {
        player = aPlayer;
        
        [player bg_addTarget:self
                      action:@selector(bindPlayerBrightness:)
            forKeyPathChange:BGKeyPath(VLCMediaPlayer, brightness)
             callImmediately:YES];
        [player bg_addTarget:self
                      action:@selector(bindPlayerContrast:)
            forKeyPathChange:BGKeyPath(VLCMediaPlayer, contrast)
             callImmediately:YES];
        [player bg_addTarget:self
                      action:@selector(bindPlayerGamma:)
            forKeyPathChange:BGKeyPath(VLCMediaPlayer, gamma)
             callImmediately:YES];
        [player bg_addTarget:self
                      action:@selector(bindPlayerHue:)
            forKeyPathChange:BGKeyPath(VLCMediaPlayer, hue)
             callImmediately:YES];
        [player bg_addTarget:self
                      action:@selector(bindPlayerSaturation:)
            forKeyPathChange:BGKeyPath(VLCMediaPlayer, saturation)
             callImmediately:YES];
    }
    
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    
    brightnessSlider.doubleValue = player.brightness;
    contrastSlider.doubleValue = player.contrast;
    gammaSlider.doubleValue = player.gamma;
    hueSlider.doubleValue = player.hue;
    saturationSlider.doubleValue = player.saturation;
}



#pragma mark ---
#pragma mark Bindings
#pragma mark ---
- (void)bindPlayerBrightness:(NSDictionary *)change
{
    brightnessSlider.doubleValue = player.brightness;
}

- (void)bindPlayerContrast:(NSDictionary *)change
{
    contrastSlider.doubleValue = player.contrast;
}

- (void)bindPlayerGamma:(NSDictionary *)change
{
    gammaSlider.doubleValue = player.gamma;
}

- (void)bindPlayerHue:(NSDictionary *)change
{
    hueSlider.doubleValue = player.hue;
}

- (void)bindPlayerSaturation:(NSDictionary *)change
{
    saturationSlider.doubleValue = player.saturation;
}



#pragma mark ---
#pragma mark Actions
#pragma mark ---
- (IBAction)brightnessSliderAction:(id)sender
{
    player.adjustFilterEnabled = NO;
    player.brightness = brightnessSlider.doubleValue;
    player.adjustFilterEnabled = YES;
}

- (IBAction)contrastSliderAction:(id)sender
{
    player.adjustFilterEnabled = NO;
    player.contrast = contrastSlider.doubleValue;
    player.adjustFilterEnabled = YES;
}

- (IBAction)gammaSliderAction:(id)sender
{
    player.adjustFilterEnabled = NO;
    player.gamma = gammaSlider.doubleValue;
    player.adjustFilterEnabled = YES;
}

- (IBAction)hueSliderAction:(id)sender
{
    player.adjustFilterEnabled = NO;
    player.hue = hueSlider.doubleValue;
    player.adjustFilterEnabled = YES;
}

- (IBAction)saturationSliderAction:(id)sender
{
    player.adjustFilterEnabled = NO;
    player.saturation = saturationSlider.doubleValue;
    player.adjustFilterEnabled = YES;
}

@end
